<template>
  <article class="view view--gallery-image-edit">
    <LoadingSpinner v-if="loading" />
    <div v-if="loaded" class="mb-3">
      <img :src="thumb" />
    </div>
    <VForm
      v-if="loaded"
      name="image-form"
      :fields="fields"
      :modelState="modelState"
      buttonText="Update"
      buttonIconClass="bi bi-save-fill"
      :busy="updating"
      busyButtonText="Updating..."
      @submit="onSubmit"
    />
  </article>
</template>

<script>
import { ref, computed, onMounted } from 'vue'
import { useRoute, useRouter } from 'vue-router'
import { useStore } from 'vuex'
import { ValidationHelper, LoadingSpinner, VForm, useApi, useNotification, useVForm } from '../../../core'
import { useAuth } from '../../../identity'
import ImageHelper from '../../lib/image-helper.js'
import ImagesApi from '../../api/images-api.js'

export default {
  name: 'GalleryImageEditView',
  components: {
    LoadingSpinner,
    VForm,
  },
  setup() {
    const store = useStore()
    const route = useRoute()
    const router = useRouter()
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const vform = useVForm()
    const imagesApi = new ImagesApi(api, auth)

    const title = ref('Edit image')
    const loading = ref(false)
    const loaded = ref(false)
    const image = ref(undefined)
    const modelState = ref({})
    const updating = ref(false)
    const fields = ref([
      {
        type: 'text',
        name: 'filenameWithoutExtension',
        label: 'Filename (without extension)',
        maxlength: 195,
        validate: 'required',
        value: '',
      },
      {
        type: 'text',
        name: 'extension',
        label: 'Extension',
        disabled: true,
        value: '',
      },
      {
        type: 'text',
        name: 'caption',
        label: 'Caption',
        maxlength: 200,
        value: '',
      },
    ])

    const imageId = computed(() => {
      return ValidationHelper.getInteger(route.params.imageId, 0)
    })

    const selecting = computed(() => {
      return ValidationHelper.getBoolean(route.query.selecting, false) && Boolean(store.state.gallery.formName)
    })

    const thumb = computed(() => {
      return image.value ? ImageHelper.getImageUrl(api.storageBaseUrl, image.value, 'thumb') : ''
    })

    const breadcrumbs = computed(() => {
      return [
        {
          text: 'Users',
          route: { name: 'identity-users' },
        },
        {
          text: store.state.identity.session.username,
          route: store.state.identity.session.username
            ? { name: 'identity-user-profile', params: { username: store.state.identity.session.username } }
            : null,
        },
        {
          text: `Gallery`,
          route: store.state.identity.session.username
            ? { name: 'gallery-albums', params: { username: store.state.identity.session.username } }
            : null,
        },
        {
          text: title.value,
          route: null, // No link to self
        },
      ]
    })

    const loadAsync = async () => {
      loading.value = true
      loaded.value = false
      image.value = null

      try {
        const response = await imagesApi.readAsync(imageId.value, { expand: 'all' })
        image.value = response.data
        loaded.value = true

        fields.value = vform.set(fields.value, {
          filenameWithoutExtension: image.value.filename.slice(0, -image.value.extension.length),
          extension: image.value.extension.toLowerCase(),
          caption: image.value.caption,
        })
      } catch (ex) {
        notify.error('There was a problem getting the image.', ex)
      } finally {
        loading.value = false
      }
    }

    const onSubmit = async (form) => {
      updating.value = true

      try {
        const response = await imagesApi.updateAsync(image.value.id, {
          filename: form.filenameWithoutExtension + form.extension,
          caption: form.caption,
        })

        notify.success(`Image updated successfully.`)
        router.push({
          name: 'gallery-images',
          params: { username: store.state.identity.session.username, alias: response.data.album.alias },
          query: { selecting: selecting.value ? 'true' : undefined },
        })
      } catch (ex) {
        if (ex.response.data?.modelState) {
          modelState.value = ex.response.data.modelState
        } else {
          notify.error(`There was a problem updating the image.`, ex)
        }
      } finally {
        updating.value = false
      }
    }

    onMounted(async () => {
      store.dispatch('core/setTitle', title.value)
      store.dispatch('core/setBreadcrumbs', breadcrumbs.value)
      loadAsync()
    })

    return {
      title,
      loading,
      loaded,
      image,
      modelState,
      updating,
      fields,
      imageId,
      selecting,
      thumb,
      breadcrumbs,
      onSubmit,
    }
  },
}
</script>
